'***********************************************************************************************************************
'Class Name:        FrmTaxReturn1040EZ.vb
'Version:           1.00
'Programmer/s:      Spiros Velianitis
'Date:              Jan 6, 2015
'Purpose:           This is the Assignment 1 for MIS 120. This application calculates the Tax Return for
'                   form 1040EZ. Perform the necessary calculations for the 1040EZ tax return.
'***********************************************************************************************************************
Public Class FrmTaxReturn1040EZ

    Private mdblWages As Double = 0, _
            mdblTaxableInterest As Double = 0, _
            mdblUnemploymentCompensation As Double = 0, _
            mdblIncomeTaxWithheld As Double = 0, _
            mdblEIC As Double = 0, _
            mdblNonTaxableCompatPayElection As Double = 0

    Private mintNumberOfTaxpayers As Integer = 0, _
            mintNumberOfDependentTaxpayers As Integer = 0

    Private myTaxReturn As clsTaxReturn

    Private Sub displayError(ByRef ex As Object)
        MessageBox.Show(ex.message, "Application Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Me.txtResult.Clear()
    End Sub

    Private Sub radIndividual_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radIndividual.CheckedChanged
        mintNumberOfTaxpayers = 1
        Me.chkSpouse.Checked = False
        Me.chkSpouse.Enabled = False
        btnAddSpouce.Enabled = False
        txtSLastName.Text = Nothing
        txtSFirstName.Text = Nothing
        btnAddSpouce.Enabled = False
        btnDeleteSpouce.Enabled = False
    End Sub

    Private Sub RadioButton1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radJoint.CheckedChanged
        mintNumberOfTaxpayers = 2
        Me.chkSpouse.Enabled = True
        displaySpouce()
    End Sub

    Private Sub ExitmnuiExit_Click(sender As Object, e As EventArgs) Handles ExitmnuiExit.Click
        Me.Close()
    End Sub

    Private Sub mnuAbout_Click(sender As Object, e As EventArgs) Handles mnuHelp.Click
        Dim objFormAbout As New frmAbout
        objFormAbout.ShowDialog()
    End Sub

    Private Sub txtWages_TextChanged(sender As Object, e As EventArgs) Handles txtWages.TextChanged
        hideUpdateButton()
    End Sub

    Private Sub hideUpdateButton()
        If txtWages.Text.Trim = "" Or txtTaxableInterest.Text.Trim = "" Or _
            txtEIC.Text.Trim = "" Or txtFederalIncomeTaxWithheld.Text.Trim = "" Or _
            txtNontaxableCompatPayElection.Text.Trim = "" Or txtUnemploymentCompensation.Text.Trim = "" Then
            btnUpdate.Enabled = False
        Else
            btnUpdate.Enabled = True
        End If
    End Sub

    Private Sub txtTaxableInterest_TextChanged(sender As Object, e As EventArgs) Handles txtTaxableInterest.TextChanged
        hideUpdateButton()
    End Sub

    Private Sub txtUnemploymentCompensation_TextChanged(sender As Object, e As EventArgs) Handles txtUnemploymentCompensation.TextChanged
        hideUpdateButton()
    End Sub

    Private Sub txtFederalIncomeTaxWithheld_TextChanged(sender As Object, e As EventArgs) Handles txtFederalIncomeTaxWithheld.TextChanged
        hideUpdateButton()
    End Sub

    Private Sub txtEIC_TextChanged(sender As Object, e As EventArgs) Handles txtEIC.TextChanged
        hideUpdateButton()
    End Sub

    Private Sub txtNontaxableCompatPayElection_TextChanged(sender As Object, e As EventArgs) Handles txtNontaxableCompatPayElection.TextChanged
        hideUpdateButton()
    End Sub

    Private Sub btnFind_Click(sender As Object, e As EventArgs) Handles btnFind.Click
        Try
            myTaxReturn = clsTaxReturnDA.getTaxReturn(CInt(txtTPID.Text), CInt(txtTaxYear.Text))
            displayTaxReturn()
            panelMain.Enabled = True
        Catch ex As KeyNotFoundException
            If (MessageBox.Show("This tax return record cannot be found. Do you want to create a new tax return?", "Record not found", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = Windows.Forms.DialogResult.Yes) Then
                btnInsert.Enabled = True
                panelMain.Enabled = True
                clearform()
                btnInsert.Enabled = True
            Else
                btnInsert.Enabled = False
                panelMain.Enabled = False
                btnInsert.Enabled = False
            End If
        Catch ex As Exception
            lblMessages.Text = ex.Message
            panelMain.Enabled = False
        End Try
    End Sub
    Private Sub displayTaxReturn()
        Try
            Dim dblResult As Double = myTaxReturn.calculateTaxReturn()
            txtWages.Text = myTaxReturn.Wages
            txtTaxableInterest.Text = myTaxReturn.TaxableInterest
            txtUnemploymentCompensation.Text = myTaxReturn.UnemploymentCompensation
            txtFederalIncomeTaxWithheld.Text = myTaxReturn.IncomeTaxWithheld
            txtUnemploymentCompensation.Text = myTaxReturn.UnemploymentCompensation
            txtEIC.Text = myTaxReturn.EIC
            txtNontaxableCompatPayElection.Text = myTaxReturn.CompatPay
            'Sets the correct status for the list box
            If (myTaxReturn.NumberOfTaxpayers = 1) Then
                radIndividual.Checked = True
            Else
                radJoint.Checked = True
            End If

            'Sets the correct status for the checkboxes
            If myTaxReturn.NumberOfDependentTaxpayers.StartsWith("1") Then
                Me.chkYou.Checked = True
            End If

            If myTaxReturn.NumberOfDependentTaxpayers.EndsWith("1") Then
                Me.chkSpouse.Checked = True
            End If

            If dblResult > 0 Then
                Me.lblResult.Text = "13a. This is your refund."
                Me.lblResult.ForeColor = Color.Black
            Else
                Me.lblResult.Text = "14. This is the amount you owe."
                Me.lblResult.ForeColor = Color.Red
            End If

            Me.txtResult.Text = Format(dblResult, "C")
            Me.txtAdjustedGrossIncome.Text = Format(myTaxReturn.AdjustedGrossIncome, "C")
            Me.txtLine5.Text = Format(myTaxReturn.ExcemptionAmount, "c")
            Me.txtTaxableIncome.Text = Format(myTaxReturn.TaxableIncome, "c")
            Me.txtTotalPayments.Text = Format(myTaxReturn.TotalPayments, "c")
            Me.txtTax.Text = Format(myTaxReturn.Tax, "c")
            Me.lblMessages.Text = "Your tax return has been calculated"
        Catch ex As InvalidOperationException
            Me.displayError(ex)
        Catch ex As Exception
            Me.displayError(ex)
        End Try
    End Sub

    Private Sub displayTaxPayer()
        Try
            Dim myTaxPayer As TaxPayerStructure = clsTaxPayerDA.getTaxPayer(CInt(txtTPID.Text))
            txtTPLastName.Text = myTaxPayer.strTaxPayerLastName
            txtTPFirstName.Text = myTaxPayer.strTaxPayerFirstName & ", " & myTaxPayer.strTaxPayerInitial
            txtAddress.Text = myTaxPayer.strTaxPayerAddress & ", " & myTaxPayer.strTaxPayerCity & ", " & myTaxPayer.strTaxPayerState & ", " & myTaxPayer.strTaxPayerZip
            btnFind.Enabled = True
        Catch ex As KeyNotFoundException
            MessageBox.Show(ex.Message, "DATABASE ERROR", MessageBoxButtons.OK, MessageBoxIcon.Stop)
            btnFind.Enabled = False
            txtTPID.Focus()
        Catch ex As Exception
            MessageBox.Show(ex.Message, "DATABASE ERROR", MessageBoxButtons.OK, MessageBoxIcon.Stop)
            btnFind.Enabled = False
            txtTPID.Focus()
        End Try
    End Sub

    Private Sub displaySpouce()
        Try
            Dim myJointTaxPayer As SpouceTableStructure = clsJointTaxPayerDA.getSpouce(txtTPID.Text)
            txtSLastName.Text = myJointTaxPayer.strJointLastName
            txtSFirstName.Text = myJointTaxPayer.strJointFirstName & ", " & myJointTaxPayer.strJointInitial
            btnDeleteSpouce.Enabled = True
            btnAddSpouce.Enabled = False
        Catch ex As KeyNotFoundException
            txtSLastName.Text = "Not Found"
            txtSFirstName.Text = "Not Found"
            btnAddSpouce.Enabled = True
            btnDeleteSpouce.Enabled = False
        Catch ex As Exception
            lblMessages.Text = ex.Message
            btnAddSpouce.Enabled = True
            btnDeleteSpouce.Enabled = False
        End Try
    End Sub

    Private Sub btnUpdate_Click(sender As Object, e As EventArgs) Handles btnUpdate.Click
        Try
            Dim newTaxReturn As clsTaxReturn

            Dim intNumberOfTaxPayers = 0
            If radIndividual.Checked Then
                intNumberOfTaxPayers = 1
            Else
                intNumberOfTaxPayers = 2
            End If

            Dim strDependentTaxPayerStatus As String
            Dim intNumberOfDependendTaxPayers As Integer

            If chkYou.Checked Then
                strDependentTaxPayerStatus = "1"
                intNumberOfDependendTaxPayers = 1
            Else
                strDependentTaxPayerStatus = "0"
            End If

            If chkSpouse.Checked Then
                strDependentTaxPayerStatus = strDependentTaxPayerStatus & "1"
                intNumberOfDependendTaxPayers = intNumberOfDependendTaxPayers + 1
            Else
                strDependentTaxPayerStatus = strDependentTaxPayerStatus & "0"
            End If

            newTaxReturn = New clsTaxReturn(CInt(txtTPID.Text), txtTaxYear.Text, CDbl(txtWages.Text), _
                             CDbl(txtTaxableInterest.Text), CDbl(txtUnemploymentCompensation.Text), CDbl(txtFederalIncomeTaxWithheld.Text), _
                             CDbl(txtEIC.Text), CDbl(txtNontaxableCompatPayElection.Text), intNumberOfTaxPayers, strDependentTaxPayerStatus)
            If (clsTaxReturnDA.updateTaxReturn(newTaxReturn)) = 0 Then
                MessageBox.Show("ERROR DB205: Tax Return was not updated. Reason is unknown.", "ERROR", MessageBoxButtons.OK, MessageBoxIcon.Error)

            Else
                MessageBox.Show("INFO DB210: Tax Return was successfully updated to the database.", "SUCCESS", MessageBoxButtons.OK, MessageBoxIcon.Information)
                myTaxReturn = newTaxReturn
                displayTaxReturn()
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message, "ERROR", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub txtTPID_LostFocus(sender As Object, e As EventArgs) Handles txtTPID.LostFocus
        If txtTPID.Text.Length > 0 Then
            displayTaxPayer()
        End If
    End Sub

    Private Sub btnAddSpouce_Click(sender As Object, e As EventArgs) Handles btnAddSpouce.Click
        Try
            Dim myJointTaxPayer As SpouceTableStructure
            myJointTaxPayer.intTaxPayerID = CInt(txtTPID.Text)
            myJointTaxPayer.strJointLastName = txtSLastName.Text
            myJointTaxPayer.strJointFirstName = txtSFirstName.Text.Split(",")(0)
            If txtSFirstName.Text.Contains(",") Then
                myJointTaxPayer.strJointInitial = txtSFirstName.Text.Split(",")(1).Trim
            Else
                myJointTaxPayer.strJointInitial = ""
            End If
            If clsJointTaxPayerDA.insertSpouce(myJointTaxPayer) = 1 Then
                btnAddSpouce.Enabled = False
                MessageBox.Show("INFO DB150: Spouce Record is successfully added to the database", "DATABASE INFO", MessageBoxButtons.OK, MessageBoxIcon.Information)
                btnDeleteSpouce.Enabled = True
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message, "DATABASE ERROR", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub clearform()
        Me.txtWages.Clear()
        Me.txtTaxableInterest.Clear()
        Me.txtUnemploymentCompensation.Clear()
        Me.txtFederalIncomeTaxWithheld.Clear()
        Me.txtEIC.Clear()
        Me.txtAdjustedGrossIncome.Clear()
        Me.txtLine5.Clear()
        Me.txtTaxableIncome.Clear()
        Me.txtTotalPayments.Clear()
        Me.txtNontaxableCompatPayElection.Clear()
        Me.txtTax.Clear()
        Me.lblResult.Text = Nothing
        Me.txtResult.Clear()
        Me.txtWages.Focus()
    End Sub

    Private Sub btnInsert_Click(sender As Object, e As EventArgs) Handles btnInsert.Click
        Try
            Dim newTaxReturn As clsTaxReturn

            Dim intNumberOfTaxPayers = 0
            If radIndividual.Checked Then
                intNumberOfTaxPayers = 1
            Else
                intNumberOfTaxPayers = 2
            End If

            Dim strDependentTaxPayerStatus As String
            Dim intNumberOfDependendTaxPayers As Integer

            If chkYou.Checked Then
                strDependentTaxPayerStatus = "1"
                intNumberOfDependendTaxPayers = 1
            Else
                strDependentTaxPayerStatus = "0"
            End If

            If chkSpouse.Checked Then
                strDependentTaxPayerStatus = strDependentTaxPayerStatus & "1"
                intNumberOfDependendTaxPayers = intNumberOfDependendTaxPayers + 1
            Else
                strDependentTaxPayerStatus = strDependentTaxPayerStatus & "0"
            End If

            newTaxReturn = New clsTaxReturn(CInt(txtTPID.Text), txtTaxYear.Text, CDbl(txtWages.Text), _
                             CDbl(txtTaxableInterest.Text), CDbl(txtUnemploymentCompensation.Text), CDbl(txtFederalIncomeTaxWithheld.Text), _
                             CDbl(txtEIC.Text), CDbl(txtNontaxableCompatPayElection.Text), intNumberOfTaxPayers, strDependentTaxPayerStatus)
            If (clsTaxReturnDA.insertTaxReturn(newTaxReturn)) = 0 Then
                MessageBox.Show("ERROR DB105: Tax Return was not added to the database. Reason is unknown.", "ERROR", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Else
                MessageBox.Show("INFO DB110: Tax Return was successfully added to the database.", "SUCCESS", MessageBoxButtons.OK, MessageBoxIcon.Information)
                myTaxReturn = newTaxReturn
                displayTaxReturn()
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message, "ERROR", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub FrmTaxReturn1040EZ_Load(sender As Object, e As EventArgs) Handles Me.Load
        frmAbout.ShowDialog()
    End Sub

    Private Sub btmDeleteSpouce_Click(sender As Object, e As EventArgs) Handles btnDeleteSpouce.Click
        Try
            clsJointTaxPayerDA.deleteSpouce(CInt(txtTPID.Text))
            btnDeleteSpouce.Enabled = False
            btnAddSpouce.Enabled = True
            txtSFirstName.Clear()
            txtSLastName.Clear()
            MessageBox.Show("INFO DB140: Spouce Record is successfully deleted from the database", "DATABASE INFO", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Catch ex As Exception
            MessageBox.Show(ex.Message, "DATABASE ERROR", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub btnUpdateSpouce_Click(sender As Object, e As EventArgs)
        Try
            Dim myJointTaxPayer As SpouceTableStructure
            myJointTaxPayer.intTaxPayerID = CInt(txtTPID.Text)
            myJointTaxPayer.strJointLastName = txtSLastName.Text
            myJointTaxPayer.strJointFirstName = txtSFirstName.Text.Split(",")(0)
            myJointTaxPayer.strJointInitial = txtSFirstName.Text.Split(",")(1).Trim
            clsJointTaxPayerDA.insertSpouce(myJointTaxPayer)
        Catch ex As Exception
            MessageBox.Show(ex.Message, "DATABASE ERROR", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub btnUpdateTaxPayer_Click(sender As Object, e As EventArgs) Handles btnUpdateTaxPayer.Click
        MessageBox.Show("INFO DB120: Updating Tax Payer records is not required in this application.", "WARNING", MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub
End Class
